<template>
    <form @submit.prevent="onSubmit" class="space-y-4">
        <div class="form-control">
            <label class="flex flex-col" for="name">
                <div>Họ tên <span class="text-red-500">*</span></div>
                <input
                    v-model="data.name"
                    id="name"
                    type="text"
                    class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                    :class="{ 'border-red-400': dataErrors.name }"
                />
            </label>
            <div
                v-if="dataErrors.name"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.name }}
            </div>
        </div>

        <div class="form-control">
            <label class="flex flex-col" for="email">
                <div>Email <span class="text-red-500">*</span></div>
                <input
                    v-model="data.email"
                    id="email"
                    type="text"
                    class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                    :class="{ 'border-red-400': dataErrors.email }"
                    placeholder="example@gmail.com"
                />
            </label>
            <div
                v-if="dataErrors.email"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.email }}
            </div>
        </div>

        <div class="form-control">
            <label class="flex flex-col" for="role">
                <div>Chức vụ <span class="text-red-500">*</span></div>
                <select
                    v-model="data.role"
                    id="role"
                    class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                    :class="{ 'border-red-400': dataErrors.role }"
                >
                    <option disabled value="">Chọn chức vụ</option>
                    <option
                        :key="role.id"
                        v-for="role in SELECT_OPTION_ROLE"
                        :value="role.id"
                    >
                        {{ role.text }}
                    </option>
                </select>
            </label>
            <div
                v-if="dataErrors.role"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.role }}
            </div>
        </div>

        <div class="form-control flex items-center gap-3">
            <BasicButton type="submit">Cập nhật</BasicButton>
            <LinkButton
                nameRoute="admin-user"
                classCustom="bg-color-danger hover:shadow-hover-danger"
            >
                Hủy
            </LinkButton>
        </div>
    </form>
</template>

<script>
import { reactive } from "vue";
import { useRouter } from "vue-router";
import { createToast } from "mosha-vue-toastify";

import useUpdateUser from "@/hooks/user/useUpdateUser";
import toolHelper from "@/helper/toolHelper";
import { SELECT_OPTION_ROLE } from "@/constants";

import BasicButton from "@/components/button/BasicButton.vue";
import LinkButton from "@/components/button/LinkButton.vue";

export default {
    components: {
        BasicButton,
        LinkButton
    },
    props: {
        user: {
            type: Object,
            required: true
        }
    },
    setup(props) {
        const data = reactive({
            name: props.user.name || "",
            email: props.user.email || "",
            role: props.user.role >= 0 ? props.user.role : ""
        });

        const dataErrors = reactive({
            name: null,
            email: null,
            role: null
        });

        const { errorResponse, onUpdateUser } = useUpdateUser();
        const router = useRouter();

        // submit form
        async function onSubmit() {
            dataErrors.name = null;
            dataErrors.email = null;
            dataErrors.role = null;

            let input_valid = true;

            // check empty input
            if (!data.name || !data.email || data.role === "") {
                input_valid = false;
                if (!data.name) dataErrors.name = "Bạn chưa nhập họ tên";
                if (!data.email) dataErrors.email = "Bạn chưa nhập email";
                if (data.role === "") dataErrors.role = "Bạn chưa chọn chức vụ";
            }

            // validate email
            if (!toolHelper.validateEmail(data.email)) {
                input_valid = false;
                dataErrors.email = "Email không đúng định dạng";
            }

            // check input valid and submit form
            if (input_valid) {
                // show loading
                document.getElementById("full-page-loading").style.display =
                    "block";

                await onUpdateUser(props.user.id, data);

                // hide loading
                document.getElementById("full-page-loading").style.display =
                    "none";

                // check error from server
                if (errorResponse.value) {
                    if (
                        errorResponse.value.name &&
                        errorResponse.value.name.length
                    ) {
                        dataErrors.name = "Bạn chưa nhập họ tên";
                    }
                    if (
                        errorResponse.value.email &&
                        errorResponse.value.email.length
                    ) {
                        dataErrors.email = errorResponse.value.email[0];
                    }
                    if (
                        errorResponse.value.role &&
                        errorResponse.value.role.length
                    ) {
                        dataErrors.role = "Bạn chưa chọn chức vụ";
                    }
                } else {
                    router.push({ name: "admin-user", params: {} });
                    createToast("Cập nhật thành công", {
                        showIcon: true,
                        type: "success"
                    });
                }
            }
        }

        return {
            SELECT_OPTION_ROLE,
            data,
            dataErrors,
            onSubmit
        };
    }
};
</script>
